Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
Code
#include <iostream>
#include <stdio.h>
#include <queue>
using namespace std;
const int MAXN=1e4;
int is_prime[MAXN];
int vis[MAXN];
void init_prime(){
for(int i=2;i<MAXN;i++){
if(vis[i]) continue;
is_prime[i]=1;
for(int j=2;i*j<MAXN;j++)
vis[i*j]=1;
}
}
struct node{
int data;
int step;
node(int i,int j){
data=i;
step=j;
}
};
bool is_link(int a,int b){
int k=1;
while(a){
if(a%10!=b%10) k--;
a /=10;
b /=10;
}
if(k==0) return true;
return false;
}
int bfs(int a,int b){
memset(vis,0,sizeof(vis));
queue<node> q;
q.push(node(a,0));
vis[a]=1;
while(!q.empty()){
node tmp=q.front();
q.pop();
if(tmp.data==b) return tmp.step;
for(int i=1e3;i<1e4;i++){
if(is_prime[i]&&!vis[i]&&is_link(tmp.data,i)){
vis[i]=1;
q.push(node(i,tmp.step+1));
}
}
}
return -1;
}
int main(){
//freopen("/Users/guoyu/Desktop/algorithm/in.txt", "r", stdin);
init_prime();
int K;
cin>>K;
while(K--){
int a,b;
cin>>a>>b;
int ans=bfs(a,b);
if(ans==-1) cout<<"Impossoble"<<endl;
else cout<<ans<<endl;
}
return 0;
}